"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_TSC_OPTIONS = exports.SAFE_BABEL_PARSER_OPTIONS = exports.BABEL_PARSER_OPTIONS = exports.MAX_LOC_IN_FILE = exports.IGNORE_FILE_PATTERN = exports.IGNORE_DIRS = exports.JS_EXTENSIONS = void 0;
const typescript_1 = __importDefault(require("typescript"));
exports.JS_EXTENSIONS = [
    ".js",
    ".jsx",
    ".cjs",
    ".mjs",
    ".ts",
    ".tsx"
];
exports.IGNORE_DIRS = [
    "node_modules",
    "venv",
    "docs",
    "test",
    "tests",
    "e2e",
    "e2e-beta",
    "examples",
    "cypress",
    "jest-cache",
    "eslint-rules",
    "codemods",
    "flow-typed",
    "i18n",
    "vendor",
    "www",
    "dist",
    "build",
];
exports.IGNORE_FILE_PATTERN = new RegExp("(chunk-vendors|app~|mock|e2e|conf|test|spec|[.-]min|\\.d)\\.(js|ts|jsx|tsx)$", "i");
exports.MAX_LOC_IN_FILE = 50000;
exports.BABEL_PARSER_OPTIONS = {
    sourceType: "unambiguous",
    allowImportExportEverywhere: true,
    allowAwaitOutsideFunction: true,
    allowNewTargetOutsideFunction: true,
    allowReturnOutsideFunction: true,
    allowSuperOutsideMethod: true,
    allowUndeclaredExports: true,
    errorRecovery: true,
    plugins: [
        "optionalChaining",
        "classProperties",
        "decorators-legacy",
        "exportDefaultFrom",
        "doExpressions",
        "numericSeparator",
        "dynamicImport",
        "jsx",
        "typescript",
    ],
};
exports.SAFE_BABEL_PARSER_OPTIONS = {
    sourceType: "module",
    allowImportExportEverywhere: true,
    allowAwaitOutsideFunction: true,
    allowReturnOutsideFunction: true,
    errorRecovery: true,
    plugins: [
        "optionalChaining",
        "classProperties",
        "decorators-legacy",
        "exportDefaultFrom",
        "doExpressions",
        "numericSeparator",
        "dynamicImport",
        "typescript",
    ],
};
exports.DEFAULT_TSC_OPTIONS = {
    target: typescript_1.default.ScriptTarget.ES2020,
    module: typescript_1.default.ModuleKind.CommonJS,
    allowJs: true,
    allowUnreachableCode: true,
    allowUnusedLabels: true,
    alwaysStrict: false,
    emitDecoratorMetadata: true,
    exactOptionalPropertyTypes: true,
    experimentalDecorators: false,
    ignoreDeprecations: "5.0",
    noStrictGenericChecks: true,
    noUncheckedIndexedAccess: false,
    noPropertyAccessFromIndexSignature: false,
    removeComments: true
};
//# sourceMappingURL=Defaults.js.map