"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringifyCircular = stringifyCircular;
exports.stringify = stringify;
/**
 * Deal with cyclic reference in json
 */
const getCircularReplacer = () => {
    const seen = new WeakSet();
    return (_, value) => {
        if (typeof value === "object" && value !== null) {
            if (seen.has(value)) {
                return;
            }
            seen.add(value);
        }
        return value;
    };
};
function stringifyCircular(data) {
    return JSON.stringify(data, getCircularReplacer());
}
function stringify(data) {
    return JSON.stringify(data);
}
//# sourceMappingURL=JsonUtils.js.map