"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tscForFiles = tscForFiles;
const Defaults = __importStar(require("./Defaults"));
const typescript_1 = __importDefault(require("typescript"));
function tscForFiles(srcFiles) {
    const program = typescript_1.default.createProgram(srcFiles, Defaults.DEFAULT_TSC_OPTIONS);
    const typeChecker = program.getTypeChecker();
    const seenTypes = new Map();
    function safeTypeToString(node) {
        try {
            return typeChecker.typeToString(node, undefined, typescript_1.default.TypeFormatFlags.NoTruncation | typescript_1.default.TypeFormatFlags.InTypeAlias);
        }
        catch (err) {
            return "any";
        }
    }
    function safeTypeWithContextToString(node, context) {
        try {
            return typeChecker.typeToString(node, context, typescript_1.default.TypeFormatFlags.NoTruncation | typescript_1.default.TypeFormatFlags.InTypeAlias);
        }
        catch (err) {
            return "any";
        }
    }
    function addType(node) {
        let typeStr;
        if (typescript_1.default.isSetAccessor(node) ||
            typescript_1.default.isGetAccessor(node) ||
            typescript_1.default.isConstructSignatureDeclaration(node) ||
            typescript_1.default.isMethodDeclaration(node) ||
            typescript_1.default.isFunctionDeclaration(node) ||
            typescript_1.default.isConstructorDeclaration(node)) {
            const signature = typeChecker.getSignatureFromDeclaration(node);
            const returnType = typeChecker.getReturnTypeOfSignature(signature);
            typeStr = safeTypeToString(returnType);
        }
        else if (typescript_1.default.isFunctionLike(node)) {
            const funcType = typeChecker.getTypeAtLocation(node);
            const funcSignature = typeChecker.getSignaturesOfType(funcType, typescript_1.default.SignatureKind.Call)[0];
            if (funcSignature) {
                typeStr = safeTypeToString(funcSignature.getReturnType());
            }
            else {
                typeStr = safeTypeWithContextToString(typeChecker.getTypeAtLocation(node), node);
            }
        }
        else {
            typeStr = safeTypeWithContextToString(typeChecker.getTypeAtLocation(node), node);
        }
        if (!["any", "unknown", "any[]", "unknown[]"].includes(typeStr))
            seenTypes.set(node.getStart(), typeStr);
        typescript_1.default.forEachChild(node, addType);
    }
    return {
        program: program,
        typeChecker: typeChecker,
        addType: addType,
        seenTypes: seenTypes
    };
}
//# sourceMappingURL=TscUtils.js.map