"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cleanVueCode = cleanVueCode;
const vueCleaningRegex = /<\/*script.*>|<style[\s\S]*style>|<\/*br>/ig;
const vueTemplateRegex = /(<template.*>)([\s\S]*)(<\/template>)/ig;
const vueCommentRegex = /<!--[\s\S]*?-->/ig;
const vueBindRegex = /(:\[)(\S*?)(])/ig;
const vuePropRegex = /\s([.:@])(\S*?=)/ig;
const vueOpenImgTag = /(<img)((?!>)[\s\S]+?)( [^\/]>)/ig;
function cleanVueCode(code) {
    return code.replace(vueCommentRegex, function (match) {
        return match.replaceAll(/\S/g, " ");
    }).replace(vueCleaningRegex, function (match) {
        return match.replaceAll(/\S/g, " ").substring(1) + ";";
    }).replace(vueBindRegex, function (_, grA, grB, grC) {
        return grA.replaceAll(/\S/g, " ") +
            grB +
            grC.replaceAll(/\S/g, " ");
    }).replace(vueTemplateRegex, function (_, grA, grB, grC) {
        return grA +
            grB.replace(vuePropRegex, function (_, grA, grB) {
                return " " + grA.replace(/[.:@]/g, " ") + grB.replaceAll(".", "-");
            })
                .replace(vueOpenImgTag, function (_, grA, grB, grC) {
                return grA + grB + grC.replace(" >", "/>");
            })
                .replaceAll("{{", "{ ")
                .replaceAll("}}", " }") +
            grC;
    });
}
//# sourceMappingURL=VueCodeCleaner.js.map