#!@@HOMEBREW_PREFIX@@/opt/node/bin/node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = __importDefault(require("./index"));
const path = __importStar(require("node:path"));
const yargs_1 = __importDefault(require("yargs"));
const helpers_1 = require("yargs/helpers");
async function main(argv) {
    const args = (0, yargs_1.default)((0, helpers_1.hideBin)(argv))
        .option("src", {
        alias: "i",
        default: ".",
        coerce: (arg) => {
            return path.resolve(arg.toString());
        },
        description: "Source directory",
    })
        .option("output", {
        alias: "o",
        default: "ast_out",
        description: "Output directory for generated AST json files",
    })
        .option("type", {
        alias: "t",
        type: "string",
        description: "Project type. Default auto-detect",
    })
        .option("recurse", {
        alias: "r",
        default: true,
        type: "boolean",
        description: "Recurse mode suitable for mono-repos",
    })
        .option("tsTypes", {
        default: true,
        type: "boolean",
        description: "Generate type mappings using the Typescript Compiler API",
    })
        .option("exclude-file", {
        default: [],
        type: "string",
        array: true,
        description: "Exclude this file. Can be specified multiple times. Default is empty."
    })
        .option("exclude-regex", {
        coerce: (arg) => {
            try {
                return new RegExp(arg.toString(), "i");
            }
            catch (err) {
                return undefined;
            }
        },
        description: "Exclude files matching this regex (matches the absolute path)."
    })
        .version()
        .help("h").parseSync();
    try {
        if (args.output === "ast_out") {
            args.output = path.join(args.src, args.output);
        }
        await (0, index_1.default)(args);
    }
    catch (e) {
        console.error(e);
        process.exit(1);
    }
}
main(process.argv);
//# sourceMappingURL=astgen.js.map